/* LZ77-DEC.C - Decoding program for standard LZ77 compression. */

#include "lz77.h"

int main(void)
{
  int i, m, p, r, c;
  int follow;

  for (;;)
  {
    /* Read the next byte containing match length and position. */

    r = getchar();
    if (r==EOF) break;

    m = r&0x3;
    p = r>>2;
    if (p!=0) m += 1;

    /* Output characters for this match, and also put them in "ahead". */

    for (i = m-1; i>=0; i--) 
    { c = back[Back_size-p-i];
      putchar(c);
      ahead[m-1-i] = c;
    }
  
    if (Debug)
    { fprintf(stderr,"Fetch m=%d p=%d '",m,p);
      for (i = m-1; i>=0; i--)
        if(back[Back_size-p-i]<32) fprintf(stderr,"\\%02x",back[Back_size-p-i]);
        else fprintf(stderr,"%c",back[Back_size-p-i]);
      fprintf(stderr,"'\n");
    }

    /* Read the following character, unless we've disable it for this length 
       match (never disabled for standard scheme).  Also put in "ahead". */

    follow = (send_follow>>m) & 1;

    if (follow)
    { c = getchar();
      if (c==EOF) break;
      putchar(c);
      ahead[m] = c;
      if (Debug)
      { fprintf(stderr,"Extra: '");
        if (ahead[m]<32) fprintf(stderr,"\\%02x",ahead[m]); 
        else fprintf(stderr,"%c",ahead[m]);
        fprintf(stderr,"'\n");
      }
    }

    /* Shift characters from "ahead" into the "back" buffer. */

    shift(m+follow);
  }

  return 0;
}
