/* LZ77-ENC.C - Encoding program for standard LZ77 compression. */

#include "lz77.h"

int main(void)
{
  int i, m, p;
  int follow;

  /* Read characters (or EOFs) into "ahead" to get started. */

  for (i = 0; i<=Max_match; i++) ahead[i] = getchar();

  /* Send triples of (length, pos, char) until we reach EOF. */

  while (ahead[0]!=EOF)
  {
    /* Find longest match. */

    match(&m,&p);

    /* Send length of match, and position if not length 0, as one byte. */

    if (m==0)
    { putchar(0);
    }
    else
    { putchar( (p<<2) | (m-1) );
    }

    /* Send the following character, unless we're at end-of-file, or we've
       disabled it for this length match (never disabled for standard scheme).*/

    follow = ahead[m]!=EOF && ((send_follow>>m) & 1);

    if (follow)
    { putchar (ahead[m]);
      if (Debug)
      { fprintf(stderr,"Extra: '");
        if (ahead[m]<32) fprintf(stderr,"\\%02x",ahead[m]); 
        else fprintf(stderr,"%c",ahead[m]);
        fprintf(stderr,"'\n");
      }
    }

    /* Shift characters from the "ahead" buffer into the "back" buffer. */

    shift(m+follow);

    /* Shift characters down in the "ahead" buffer, and read new input 
       characters into the end. */

    for (i = 0; i<=Max_match-m-follow; i++) ahead[i] = ahead[i+m+follow];
    for ( ; i<=Max_match; i++) ahead[i] = getchar();
  }

  return 0;
}
