/* LZ77-UTIL.C - Utility routines for the LZ77 programs. */

#include "lz77.h"

/* These routines operate on the global variables declared in lz77.h */


/* Shift characters in "back" down by "b", and shift "b" characters from 
   the beginning of "ahead" into the end of "back". */

void shift (int b)
{ int i;
  for (i = 0; i<Back_size-b; i++) back[i] = back[i+b];
  for ( ; i<Back_size; i++) back[i] = ahead[i-(Back_size-b)];
}


/* Look for the longest match of characters from "ahead" with characters 
   in "back".  Store the length of the match in "mptr" and the position
   of the match, counting starting at 1 from the end of "back", in "pptr". */
  
void match (int *mptr, int *pptr)
{
  int i, m, p;

  for (m = Max_match; m>0; m--)
  { for (p = 1; p<=Max_back; p++)
    { for (i = 0; i<m; i++)
      { if (back[Back_size-p-i]!=ahead[m-1-i]) goto not_a_match;
      }
      goto match;
    not_a_match: ;
    }
  }

match: 
  if (Debug)
  { fprintf(stderr,"Match '");
    for (i = 0; i<Max_match; i++) 
      if (ahead[i]<32) fprintf(stderr,"\\%02x",ahead[i]); 
      else fprintf(stderr,"%c",ahead[i]);
    fprintf(stderr,"' m=%d p=%d '",m,p);
    for (i = m-1; i>=0; i--)
      if (back[Back_size-p-i]<32) fprintf(stderr,"\\%02x",back[Back_size-p-i]); 
      else fprintf(stderr,"%c",back[Back_size-p-i]);
    fprintf(stderr,"'\n");
  }

  *mptr = m;
  *pptr = p;
}
