/* LZ77.H - Global declarations for LZ77 programs. */

#include <stdio.h>

#define Debug 0		/* Set to 1 for debug output */

#define Max_match 4	/* Maximum size of a match */
#define Max_back 63	/* Maximum distance back to end of match */

/* Flags that select which length matches are followed by the next character.
   Must always include (1<<0), since disabling the following character for a
   length 0 match might result in an infinite loop.  Note that all matches 
   are followed by the next character in the standard scheme. */

#define send_follow ((1<<4) | (1<<3) | (1<<2) | (1<<1) | (1<<0))

#define Back_size (Max_back+Max_match-1) /* Max distance back of matching char*/

unsigned char back[Back_size]; /* Saved chars in order received (recent at end).
                                  Set to 0s initially.  Unsigned so it won't
                                  be signed extended and maybe match EOF. */

int ahead[Max_match+1];	       /* Following characters to encode; declared as 
                                  int since may hold EOFs */

extern void shift (int);          /* Shift characters down and into back */
extern void match (int *, int *); /* Look for longest match */
